note
	description: "[
		Eiffel tests that can be executed by testing tool.
	]"
	author: "EiffelStudio test wizard"
	date: "$Date$"
	revision: "$Revision$"
	testing: "type/manual"

class
	APPLICATION_EXECUTION_TEST_SET

inherit
	EQA_TEST_SET
		redefine
			on_prepare,
			on_clean
		end

feature {NONE} -- Events
-- To check if something is still in the DB after execution of the test cases use the following neo4j statement
-- MATCH (n) WHERE n.user =~ "UnitTest.*" RETURN n LIMIT 25


	db : NEO4J_DATABASE

	on_prepare
			-- <Precursor>
		do
			 create db.make("http://localhost:11004")


			if attached environment.item (test_name_key) as test_case then
				if test_case.is_equal ("APPLICATION_EXECUTION_TEST_SET.test_create_task") then
					clean_test_create_task
				end
				if test_case.is_equal ("APPLICATION_EXECUTION_TEST_SET.test_get_late_tasks") then
					clean_test_get_late_tasks
				end
				if test_case.is_equal ("APPLICATION_EXECUTION_TEST_SET.test_edit_task") then
					clean_test_edit_task
				end
				if test_case.is_equal ("APPLICATION_EXECUTION_TEST_SET.test_done_filter") then
					clean_test_done_filter
				end
				if test_case.is_equal ("APPLICATION_EXECUTION_TEST_SET.test_list_all_tasks") then
					clean_test_list_all_tasks
				end
				if test_case.is_equal ("APPLICATION_EXECUTION_TEST_SET.clean_test_list_all_tasks_search_summary") then
					clean_test_list_all_tasks_search_summary
				end
				if test_case.is_equal ("APPLICATION_EXECUTION_TEST_SET.test_inbox_filter") then
					clean_test_inbox_filter
				end
				if test_case.is_equal ("APPLICATION_EXECUTION_TEST_SET.test_create_project") then
					clean_test_create_project
				end
				if test_case.is_equal ("APPLICATION_EXECUTION_TEST_SET.test_connect_project_to_task") then
					clean_test_connect_project_to_task
				end
				if test_case.is_equal ("APPLICATION_EXECUTION_TEST_SET.test_date_filter") then
					clean_test_date_filter
				end
				if test_case.is_equal ("APPLICATION_EXECUTION_TEST_SET.test_date_filter_in_project") then
					clean_test_date_filter_in_project
				end
				if test_case.is_equal ("APPLICATION_EXECUTION_TEST_SET.test_get_tasks_within_a_specific_project_concidering_status_filter_only") then
					clean_test_get_tasks_within_a_specific_project_concidering_status_filter_only
				end



			end
		end

	on_clean
			-- <Precursor>
		do
		end

		clean_test_date_filter_in_project
		local
			database_result : STRING
			db_data : NEO4J_ANSWER
		do
			database_result := db.remove_project_from_filter ("UnitTestUserBSharpAB_test_date_filter_in_project", "UnitTestUserBSharpABUID_test_date_filter_in_project4")
			database_result := db.unset_filter_inbox ("UnitTestUserBSharpAB_test_date_filter_in_project")
			database_result := db.remove_status_from_filter ("UnitTestUserBSharpAB_test_date_filter_in_project","created")
			db.remove_user ("UnitTestUserBSharpAB_test_date_filter_in_project") -- TODO How to verify that the user is removed? Make a special database query?
			db.clean_db("UnitTestUserBSharpAB_test_date_filter_in_project")
		end

		clean_test_get_tasks_within_a_specific_project_concidering_status_filter_only
		local
			database_result : STRING
			db_data : NEO4J_ANSWER
		do
			database_result := db.remove_status_from_filter ("UnitTestUserBSharpAB_test_get_tasks_within_a_specific_project_concidering_status_filter_only","created")
			db.remove_user ("UnitTestUserBSharpAB_test_get_tasks_within_a_specific_project_concidering_status_filter_only") -- TODO How to verify that the user is removed? Make a special database query?
			db.clean_db("UnitTestUserBSharpAB_test_get_tasks_within_a_specific_project_concidering_status_filter_only")
		end


		clean_test_date_filter
		local
			database_result : STRING
			db_data : NEO4J_ANSWER
		do
			database_result := db.unset_filter_inbox ("UnitTestUserBSharpAB_test_date_filter")
			database_result := db.remove_status_from_filter ("UnitTestUserBSharpAB_test_date_filter","created")
			db.remove_user ("UnitTestUserBSharpAB_test_date_filter") -- TODO How to verify that the user is removed? Make a special database query?
			db.clean_db("UnitTestUserBSharpAB_test_date_filter")
		end


		clean_test_connect_project_to_task
		local
			database_result : STRING
			db_data : NEO4J_ANSWER
		do
			db.clean_db("UnitTestUserBSharpAB_test_connect_project_to_task")

			create db_data.make_from_json (db.get_list_of_projects ("UnitTestUserBSharpAB_test_connect_project_to_task"))
			assert( "That project is removed", db_data.column_data.count = 0)

			create db_data.make_from_json (db.list_all_tasks ("UnitTestUserBSharpAB_test_connect_project_to_task"))
			assert( "That tasks is removed", db_data.column_data.count = 0)
		end




		clean_test_create_project
		local
			database_result : STRING
			db_data : NEO4J_ANSWER
		do
			db.clean_db("UnitTestUserBSharpAB3")

			create db_data.make_from_json (db.get_list_of_projects ("UnitTestUserBSharpAB3"))
			assert( "That project is removed", db_data.column_data.count = 0)
		end


		clean_test_inbox_filter
		local
			database_result : STRING
			db_data : NEO4J_ANSWER
		do
			database_result := db.unset_filter_inbox ("UnitTestUserBSharpAB2")
			database_result := db.remove_status_from_filter ("UnitTestUserBSharpAB2","created")
			db.remove_user ("UnitTestUserBSharpAB2")
			db.clean_db("UnitTestUserBSharpAB2")
		end


		clean_test_create_task
		local
			database_result : STRING
			db_data : NEO4J_ANSWER
		do
			db.clean_db("UnitTestUserBSharpAB1")

			create db_data.make_from_json (db.list_all_tasks ("UnitTestUserBSharpAB1"))
			assert( "That tasks is removed", db_data.column_data.count = 0)

		end


		clean_test_get_late_tasks
		local
			database_result : STRING
			db_data : NEO4J_ANSWER
		do
			db.clean_db("UnitTest_test_get_late_tasks")

			create db_data.make_from_json (db.list_all_tasks ("UnitTest_test_get_late_tasks"))
			assert( "That tasks is removed", db_data.column_data.count = 0)
		end

		clean_test_done_filter
		local
			database_result : STRING
			db_data : NEO4J_ANSWER
		do
			database_result := db.unset_filter_inbox ("UnitTestUserBSharpAB_test_done_filter")
			database_result := db.remove_status_from_filter ("UnitTestUserBSharpAB_test_done_filter","done")
			db.remove_user ("UnitTestUserBSharpAB_test_done_filter") -- TODO How to verify that the user is removed? Make a special database query?
			db.clean_db("UnitTestUserBSharpAB_test_done_filter")
		end

		clean_test_edit_task
		local
			database_result : STRING
			db_data : NEO4J_ANSWER
		do
			db.clean_db("UnitTest_test_edit_task")

			create db_data.make_from_json (db.list_all_tasks ("UnitTest_test_edit_task"))
			assert( "That tasks is removed", db_data.column_data.count = 0)
		end


		clean_test_list_all_tasks
		local
			database_result : STRING
			db_data : NEO4J_ANSWER
		do
			db.clean_db("UnitTest_test_list_all_tasks")

			create db_data.make_from_json (db.list_all_tasks ("UnitTest_test_list_all_tasks"))
			assert( "That tasks is removed", db_data.column_data.count = 0)
		end

		clean_test_list_all_tasks_search_summary
		local
			database_result : STRING
			db_data : NEO4J_ANSWER
		do
			db.clean_db("UnitTest_list_all_tasks_search_summary")

			create db_data.make_from_json (db.list_all_tasks ("UnitTest_list_all_tasks_search_summary"))
			assert( "That tasks is removed", db_data.column_data.count = 0)
		end



feature -- Test routines




	test_create_task

		local
			database_result : STRING
			db_data : NEO4J_ANSWER
		do
			database_result := db.create_task ("UnitTestUserBSharpAB1", "Test summary", "UnitTestUserBSharpABUID1")

			create db_data.make_from_json (db.list_all_tasks ("UnitTestUserBSharpAB1"))
			assert( "That tasks is added", db_data.column_data.count = 1)

			clean_test_create_task
		end



	test_edit_task
		Local
			database_result : STRING
			db_data : NEO4J_ANSWER
		do
			database_result := db.create_task ("UnitTest_test_edit_task", "Test summary", "UnitTest_test_edit_task_UID1")

			create db_data.make_from_json (db.edit_task ("UnitTest_test_edit_task_UID1"))
			assert( "That task info is returned", db_data.column_data.count = 1)

			across db_data.column_data as row loop

				assert( "That correct data is returned, uid", row.item[1].is_equal ("UnitTest_test_edit_task_UID1"))

				assert( "That correct data is returned, status", row.item[2].is_equal ("created"))

				assert( "That correct data is returned, summary", row.item[3].is_equal ("Test summary"))

			end

			clean_test_edit_task

		end



	test_list_all_tasks
		Local
			database_result : STRING
			db_data : NEO4J_ANSWER
		do
			database_result := db.create_task ("UnitTest_test_list_all_tasks", "Test summary", "UnitTest_test_list_all_tasks_UID1")
			database_result := db.create_task ("UnitTest_test_list_all_tasks", "Test summary", "UnitTest_test_list_all_tasks_UID2")
			database_result := db.create_task ("UnitTest_test_list_all_tasks", "Test summary", "UnitTest_test_list_all_tasks_UID3")

			create db_data.make_from_json (db.list_all_tasks ("UnitTest_test_list_all_tasks"))
			assert( "That tasks is listed", db_data.column_data.count = 3)


			clean_test_list_all_tasks


		end

	test_list_all_tasks_search_summary
		Local
			database_result : STRING
			db_data : NEO4J_ANSWER
		do
			database_result := db.create_task ("UnitTest_list_all_tasks_search_summary", "Test summary1", "UnitTest_list_all_tasks_search_summary_UID1")
			database_result := db.create_task ("UnitTest_list_all_tasks_search_summary", "Test summary2", "UnitTest_list_all_tasks_search_summary_UID2")
			database_result := db.create_task ("UnitTest_list_all_tasks_search_summary", "Test summary3", "UnitTest_list_all_tasks_search_summary_UID3")

			create db_data.make_from_json (db.list_all_tasks_search_summary ("UnitTest_list_all_tasks_search_summary", "summary"))
			assert( "That tasks is listed", db_data.column_data.count = 3)

			create db_data.make_from_json (db.list_all_tasks_search_summary ("UnitTest_list_all_tasks_search_summary", "summary1"))
			assert( "That tasks is listed", db_data.column_data.count = 1)

			create db_data.make_from_json (db.list_all_tasks_search_summary ("UnitTest_list_all_tasks_search_summary", "est summary"))
			assert( "That tasks is listed", db_data.column_data.count = 3)

			create db_data.make_from_json (db.list_all_tasks_search_summary ("UnitTest_list_all_tasks_search_summary", "2"))
			assert( "That tasks is listed", db_data.column_data.count = 1)


			clean_test_list_all_tasks_search_summary


		end





    test_get_late_tasks
		Local
			database_result : STRING
			db_data : NEO4J_ANSWER
			task : TASK_DATA
		do
			database_result := db.create_task ("UnitTest_test_get_late_tasks", "Test summary", "UnitTest_test_get_late_tasks_UID1")
			database_result := db.create_task ("UnitTest_test_get_late_tasks", "Test summary", "UnitTest_test_get_late_tasks_UID2")
			database_result := db.create_task ("UnitTest_test_get_late_tasks", "Test summary", "UnitTest_test_get_late_tasks_UID3")

			create db_data.make_from_json (db.get_late_tasks ("UnitTest_test_get_late_tasks"))
			assert( "No tasks is listed", db_data.column_data.count = 0)

			create task.make_for_test ("UnitTest_test_get_late_tasks_UID1", "summary", "2018-12-20", "2018-12-20", "notes")
			db.update_task (task)


			create db_data.make_from_json (db.get_late_tasks ("UnitTest_test_get_late_tasks"))
			assert( "One task is listed", db_data.column_data.count = 1)

			create task.make_for_test ("UnitTest_test_get_late_tasks_UID2", "summary", "2018-12-20", "2048-12-20", "notes")
			db.update_task (task)

			create db_data.make_from_json (db.get_late_tasks ("UnitTest_test_get_late_tasks"))
			assert( "Two (step 1) tasks is listed", db_data.column_data.count = 1)

			create task.make_for_test ("UnitTest_test_get_late_tasks_UID2", "summary", "2019-01-06", "2019-01-06", "notes")
			db.update_task (task)

			create db_data.make_from_json (db.get_late_tasks ("UnitTest_test_get_late_tasks"))
			assert( "Two (step 2) tasks is listed", db_data.column_data.count = 2)


			create task.make_for_test ("UnitTest_test_get_late_tasks_UID2", "summary", db.current_date + "T23:58", db.current_date + "T23:58", "notes")
			db.update_task (task)

			create db_data.make_from_json (db.get_late_tasks ("UnitTest_test_get_late_tasks"))
			assert( "Two (step 3) tasks is listed", db_data.column_data.count = 2)

			clean_test_get_late_tasks

		end


	test_inbox_filter
		Local
			database_result : STRING
			db_data : NEO4J_ANSWER

		do
			database_result := db.create_task ("UnitTestUserBSharpAB2", "Test summary", "UnitTestUserBSharpABUID1")
			database_result := db.create_task ("UnitTestUserBSharpAB2", "Test summary", "UnitTestUserBSharpABUID2")
			database_result := db.create_task ("UnitTestUserBSharpAB2", "Test summary", "UnitTestUserBSharpABUID3")


			db.add_user ("UnitTestUserBSharpAB2")
-- Verify that we have 3 items in inbox.

			create db_data.make_from_json (db.list_tasks_without_project ("UnitTestUserBSharpAB2"))
			assert( "That tasks is added", db_data.column_data.count = 3)

			database_result := db.set_filter_inbox ("UnitTestUserBSharpAB2")

-- Still no tasks since no statuses are set

			create db_data.make_from_json (db.get_inbox_according_to_filter_date_filter_not_set ("UnitTestUserBSharpAB2"))
			assert( "No tasks since filter is not set", db_data.column_data.count = 0)

			database_result := db.add_status_to_filter ("UnitTestUserBSharpAB2","created")

-- Now we should get 3 items

			create db_data.make_from_json (db.get_inbox_according_to_filter_date_filter_not_set ("UnitTestUserBSharpAB2"))
			assert( "Filter gives 3 results", db_data.column_data.count = 3)

-- TODO How to verify that the user is removed. Make a special database query where I make sure it returns x number of matches  MATCH?

			clean_test_inbox_filter
		end

	test_create_project
		Local
			database_result : STRING
			db_data : NEO4J_ANSWER
		do
			db.create_project ("UnitTestUserBSharpAB3", "Project name", "UnitTestUserBSharpABUID3")

			create db_data.make_from_json (db.get_list_of_projects ("UnitTestUserBSharpAB3"))
			assert( "That project is added", db_data.column_data.count = 1)

			clean_test_create_project

		end


		test_connect_project_to_task
		Local
			database_result : STRING
			db_data : NEO4J_ANSWER
		do
			database_result := db.create_task ("UnitTestUserBSharpAB_test_connect_project_to_task", "Test summary", "UnitTestUserBSharpABUID_test_connect_project_to_task_1")
			db.create_project ("UnitTestUserBSharpAB_test_connect_project_to_task", "Project name", "UnitTestUserBSharpABUID_test_connect_project_to_task_2")
			database_result := db.connect_task_to_project ("UnitTestUserBSharpABUID_test_connect_project_to_task_2", "UnitTestUserBSharpABUID_test_connect_project_to_task_1")

			create db_data.make_from_json ( db.get_projects_that_refers_to_the_task ("UnitTestUserBSharpAB_test_connect_project_to_task",  "UnitTestUserBSharpABUID_test_connect_project_to_task_1"))
			assert( "That project is connected", db_data.column_data.count = 1)

			clean_test_connect_project_to_task
		end

		test_date_filter -- in inbox (also tests that tasks in inbox that is not set is listed if no-start-date filter is set.
		local
			database_result : STRING
			db_data : NEO4J_ANSWER
			task : TASK_DATA
			datefilter: FILTER_DATE_DATA
		do
			database_result := db.create_task ("UnitTestUserBSharpAB_test_date_filter", "Test summary", "UnitTestUserBSharpABUID_test_date_filter1")
			database_result := db.create_task ("UnitTestUserBSharpAB_test_date_filter", "Test summary", "UnitTestUserBSharpABUID_test_date_filter2")
			database_result := db.create_task ("UnitTestUserBSharpAB_test_date_filter", "Test summary", "UnitTestUserBSharpABUID_test_date_filter3")


			db.add_user ("UnitTestUserBSharpAB_test_date_filter")
			database_result := db.set_filter_inbox ("UnitTestUserBSharpAB_test_date_filter")
			database_result := db.add_status_to_filter ("UnitTestUserBSharpAB_test_date_filter","created")


			create db_data.make_from_json (db.get_inbox_according_to_filter_no_start_date_set ("UnitTestUserBSharpAB_test_date_filter"))
			assert( "Three tasks has no start date set", db_data.column_data.count = 3)


			create task.make_for_test ("UnitTestUserBSharpABUID_test_date_filter1", "summary", "2018-12-20", "", "notes")
			db.update_task (task)

			create task.make_for_test ("UnitTestUserBSharpABUID_test_date_filter2", "summary", "2018-12-30", "", "notes")
			db.update_task (task)




			create datefilter.make_for_test( "2018-12-31", "")
			database_result := db.set_filter_date ("UnitTestUserBSharpAB_test_date_filter", datefilter)


			create db_data.make_from_json (db.get_inbox_according_to_filter_date_filter_set ("UnitTestUserBSharpAB_test_date_filter"))
			assert( "Two tasks", db_data.column_data.count = 2)



			create db_data.make_from_json (db.get_inbox_according_to_filter_no_start_date_set ("UnitTestUserBSharpAB_test_date_filter"))
			assert( "One task has no start date set", db_data.column_data.count = 1)



			create datefilter.make_for_test( "2018-12-25", "")
			database_result := db.set_filter_date ("UnitTestUserBSharpAB_test_date_filter", datefilter)

			create db_data.make_from_json (db.get_inbox_according_to_filter_date_filter_set ("UnitTestUserBSharpAB_test_date_filter"))
			assert( "One task", db_data.column_data.count = 1)

			create datefilter.make_for_test( "2018-12-15", "")
			database_result := db.set_filter_date ("UnitTestUserBSharpAB_test_date_filter", datefilter)

			create db_data.make_from_json (db.get_inbox_according_to_filter_date_filter_set ("UnitTestUserBSharpAB_test_date_filter"))
			assert( "No tasks", db_data.column_data.count = 0)

			clean_test_date_filter




-- If this test case fail, then clean the test database by the following commands
-- MATCH (n:FILTER  {user : "UnitTestUserBSharpAB_test_date_filter"})-[i]->(s:STATUS) delete i
-- MATCH (n{user : "UnitTestUserBSharpAB_test_date_filter"} ) delete n


		end

		test_done_filter
		local
			database_result : STRING
			db_data : NEO4J_ANSWER
			task : TASK_DATA
			datefilter: FILTER_DATE_DATA
		do
			database_result := db.create_task ("UnitTestUserBSharpAB_test_done_filter", "Test summary", "UnitTestUserBSharpAB_test_done_filterUID1")
			database_result := db.create_task ("UnitTestUserBSharpAB_test_done_filter", "Test summary", "UnitTestUserBSharpAB_test_done_filterUID2")
			database_result := db.create_task ("UnitTestUserBSharpAB_test_done_filter", "Test summary", "UnitTestUserBSharpAB_test_done_filterUID3")



			db.add_user ("UnitTestUserBSharpAB_test_done_filter")
			database_result := db.set_filter_inbox ("UnitTestUserBSharpAB_test_done_filter")
			database_result := db.add_status_to_filter ("UnitTestUserBSharpAB_test_done_filter","done")


			create db_data.make_from_json (db.get_inbox_according_to_filter_date_filter_not_set ("UnitTestUserBSharpAB_test_done_filter"))
			assert( "Zero tasks", db_data.column_data.count = 0)

			database_result := db.set_task_to_done ("UnitTestUserBSharpAB_test_done_filterUID1")

			create db_data.make_from_json (db.get_inbox_according_to_filter_date_filter_not_set ("UnitTestUserBSharpAB_test_done_filter"))
			assert( "Zero tasks", db_data.column_data.count = 1)

			database_result := db.undo_task ("UnitTestUserBSharpAB_test_done_filterUID1")

			create db_data.make_from_json (db.get_inbox_according_to_filter_date_filter_not_set ("UnitTestUserBSharpAB_test_done_filter"))
			assert( "Zero tasks", db_data.column_data.count = 0)

			clean_test_done_filter


-- If this test case clean the test database by the following commands
-- MATCH (n:FILTER  {user : "UnitTestUserBSharpAB_test_done_filter"})-[i]->(s:STATUS) delete i
-- MATCH (n{user : "UnitTestUserBSharpAB_test_done_filter"} ) delete n


		end

		test_date_filter_in_project -- in project, also test no-start-date filter
		local
			database_result : STRING
			db_data : NEO4J_ANSWER
			task : TASK_DATA
			datefilter: FILTER_DATE_DATA
		do
			database_result := db.create_task ("UnitTestUserBSharpAB_test_date_filter_in_project", "Test summary", "UnitTestUserBSharpABUID_test_date_filter_in_project1")
			database_result := db.create_task ("UnitTestUserBSharpAB_test_date_filter_in_project", "Test summary", "UnitTestUserBSharpABUID_test_date_filter_in_project2")
			database_result := db.create_task ("UnitTestUserBSharpAB_test_date_filter_in_project", "Test summary", "UnitTestUserBSharpABUID_test_date_filter_in_project3")



			db.create_project ("UnitTestUserBSharpAB_test_date_filter_in_project", "Project name", "UnitTestUserBSharpABUID_test_date_filter_in_project4")


			db.add_user ("UnitTestUserBSharpAB_test_date_filter_in_project")
			database_result := db.set_filter_inbox ("UnitTestUserBSharpAB_test_date_filter_in_project")
			database_result := db.add_status_to_filter ("UnitTestUserBSharpAB_test_date_filter_in_project","created")

			database_result := db.connect_task_to_project ("UnitTestUserBSharpABUID_test_date_filter_in_project4", "UnitTestUserBSharpABUID_test_date_filter_in_project1")
			database_result := db.connect_task_to_project ("UnitTestUserBSharpABUID_test_date_filter_in_project4", "UnitTestUserBSharpABUID_test_date_filter_in_project2")
			database_result := db.connect_task_to_project ("UnitTestUserBSharpABUID_test_date_filter_in_project4", "UnitTestUserBSharpABUID_test_date_filter_in_project3")

			database_result := db.add_project_to_filter ("UnitTestUserBSharpAB_test_date_filter_in_project", "UnitTestUserBSharpABUID_test_date_filter_in_project4")



			create db_data.make_from_json (db.get_tasks_with_current_filter_with_no_start_date_set ("UnitTestUserBSharpAB_test_date_filter_in_project"))
			assert( "Three tasks has no start date set.", db_data.column_data.count = 3)


			create task.make_for_test ("UnitTestUserBSharpABUID_test_date_filter_in_project1", "summary", "2018-12-20", "", "notes")
			db.update_task (task)

			create task.make_for_test ("UnitTestUserBSharpABUID_test_date_filter_in_project2", "summary", "2018-12-30", "", "notes")
			db.update_task (task)



			create datefilter.make_for_test( "2018-12-31", "")
			database_result := db.set_filter_date ("UnitTestUserBSharpAB_test_date_filter_in_project", datefilter)


			create db_data.make_from_json (db.get_tasks_with_current_filter_but_start_date_set ("UnitTestUserBSharpAB_test_date_filter_in_project"))
			assert( "Two tasks", db_data.column_data.count = 2)


			create db_data.make_from_json (db.get_tasks_with_current_filter_with_no_start_date_set ("UnitTestUserBSharpAB_test_date_filter_in_project"))
			assert( "One task has no start date set.", db_data.column_data.count = 1)




			create datefilter.make_for_test( "2018-12-25", "")
			database_result := db.set_filter_date ("UnitTestUserBSharpAB_test_date_filter_in_project", datefilter)

			create db_data.make_from_json (db.get_tasks_with_current_filter_but_start_date_set ("UnitTestUserBSharpAB_test_date_filter_in_project"))
			assert( "One task", db_data.column_data.count = 1)

			create datefilter.make_for_test( "2018-12-15", "")
			database_result := db.set_filter_date ("UnitTestUserBSharpAB_test_date_filter_in_project", datefilter)

			create db_data.make_from_json (db.get_tasks_with_current_filter_but_start_date_set ("UnitTestUserBSharpAB_test_date_filter_in_project"))
			assert( "No tasks", db_data.column_data.count = 0)


			clean_test_date_filter_in_project


-- clean DB by
-- MATCH (n:FILTER  {user : "UnitTestUserBSharpAB_test_date_filter_in_project"})-[i]->(s:PROJECT) delete i
-- MATCH (n:FILTER  {user : "UnitTestUserBSharpAB_test_date_filter_in_project"})-[i]->(s:STATUS) delete i
-- MATCH (s:PROJECT) -[i]-> (n:TASK {user : "UnitTestUserBSharpAB_test_date_filter_in_project"}) delete i
-- MATCH (n{user : "UnitTestUserBSharpAB_test_date_filter_in_project"} ) delete n


		end


		test_get_tasks_within_a_specific_project_concidering_status_filter_only
		local
			database_result : STRING
			db_data : NEO4J_ANSWER
			task : TASK_DATA
			datefilter: FILTER_DATE_DATA
		do
			database_result := db.create_task ("UnitTestUserBSharpAB_test_get_tasks_within_a_specific_project_concidering_status_filter_only", "Test summary", "UnitTestUserBSharpABUID_test_get_tasks_within_a_specific_project_concidering_status_filter_only1")
			database_result := db.create_task ("UnitTestUserBSharpAB_test_get_tasks_within_a_specific_project_concidering_status_filter_only", "Test summary", "UnitTestUserBSharpABUID_test_get_tasks_within_a_specific_project_concidering_status_filter_only2")
			database_result := db.create_task ("UnitTestUserBSharpAB_test_get_tasks_within_a_specific_project_concidering_status_filter_only", "Test summary", "UnitTestUserBSharpABUID_test_get_tasks_within_a_specific_project_concidering_status_filter_only3")

			db.create_project ("UnitTestUserBSharpAB_test_get_tasks_within_a_specific_project_concidering_status_filter_only", "Project name", "UnitTestUserBSharpABUID_test_get_tasks_within_a_specific_project_concidering_status_filter_only4")


			db.add_user ("UnitTestUserBSharpAB_test_get_tasks_within_a_specific_project_concidering_status_filter_only")
			database_result := db.add_status_to_filter ("UnitTestUserBSharpAB_test_get_tasks_within_a_specific_project_concidering_status_filter_only","created")

			create db_data.make_from_json (db.get_tasks_within_a_specific_project_concidering_status_filter_only ("UnitTestUserBSharpAB_test_get_tasks_within_a_specific_project_concidering_status_filter_only", "UnitTestUserBSharpABUID_test_get_tasks_within_a_specific_project_concidering_status_filter_only4" ))
			assert( "Not assigend to project yet.", db_data.column_data.count = 0)


			database_result := db.connect_task_to_project ("UnitTestUserBSharpABUID_test_get_tasks_within_a_specific_project_concidering_status_filter_only4", "UnitTestUserBSharpABUID_test_get_tasks_within_a_specific_project_concidering_status_filter_only1")
			create db_data.make_from_json (db.get_tasks_within_a_specific_project_concidering_status_filter_only ("UnitTestUserBSharpAB_test_get_tasks_within_a_specific_project_concidering_status_filter_only", "UnitTestUserBSharpABUID_test_get_tasks_within_a_specific_project_concidering_status_filter_only4" ))
			assert( "One task assigned to project.", db_data.column_data.count = 1)


			database_result := db.connect_task_to_project ("UnitTestUserBSharpABUID_test_get_tasks_within_a_specific_project_concidering_status_filter_only4", "UnitTestUserBSharpABUID_test_get_tasks_within_a_specific_project_concidering_status_filter_only2")
			database_result := db.connect_task_to_project ("UnitTestUserBSharpABUID_test_get_tasks_within_a_specific_project_concidering_status_filter_only4", "UnitTestUserBSharpABUID_test_get_tasks_within_a_specific_project_concidering_status_filter_only3")


			create db_data.make_from_json (db.get_tasks_within_a_specific_project_concidering_status_filter_only ("UnitTestUserBSharpAB_test_get_tasks_within_a_specific_project_concidering_status_filter_only", "UnitTestUserBSharpABUID_test_get_tasks_within_a_specific_project_concidering_status_filter_only4" ))
			assert( "Three tasks connected to project.", db_data.column_data.count = 3)

			clean_test_get_tasks_within_a_specific_project_concidering_status_filter_only
	end


	test_add_and_remove_user
		Local
			database_result : STRING
		do
			db.add_user ("UnitTestUserBSharpAB_test_add_and_remove_user")
			db.remove_user ("UnitTestUserBSharpAB_test_add_and_remove_user")
-- TODO How to verify that the user is removed. Make a special database query where I make sure it returns zero MATCH?
		end




end


