note
	description: "[
		Eiffel tests that can be executed by testing tool.
	]"
	author: "EiffelStudio test wizard"
	date: "$Date$"
	revision: "$Revision$"
	testing: "type/manual"

class
	NEO4J_DATABASE_UTILITY_TEST_SET

inherit
	EQA_TEST_SET
		redefine
			on_prepare,
			on_clean
		end

feature {NONE} -- Events

	db : NEO4J_DATABASE


	on_prepare
			-- <Precursor>
		do
			create db.make("http://localhost:11004")
			assert ("not_implemented", True)
		end

	on_clean
			-- <Precursor>
		do
			assert ("not_implemented", True)
		end

feature -- Test routines

	test_escape_characters
			-- New test routine
		note
			testing:  "covers/{NEO4J_DATABASE}.escape_characters"
		do
			assert (" Manage normal string", db.escape_characters ("AAAA").is_equal ("AAAA"))
			assert ("Test singel ' ", db.escape_characters ("%'").is_equal ("\\%'"))
			assert ("Test singel %" ", db.escape_characters ("\%"").is_equal ("\\\%""))
			assert ("Test singel \ ", db.escape_characters ("\").is_equal ("\\"))
			assert ("Test double \ ", db.escape_characters ("\\").is_equal ("\\\\"))
			assert ("Test newline ", db.escape_characters ("\n").is_equal ("\n"))
			assert ("Test tab ", db.escape_characters ("\t").is_equal ("\t"))

			assert ("Test singel \ plus space character", db.escape_characters ("\ ").is_equal ("\\ "))

		end

	test_replace_escaped_characters
			-- New test routine
		note
			testing:  "covers/{NEO4J_DATABASE}.replace_escaped_characters"
		do
			assert (" Manage normal string", db.replace_escaped_characters ("AAAA").is_equal ("AAAA"))
			assert ("Test singel ' ", db.replace_escaped_characters ("\'").is_equal ("'"))
			assert ("Test singel %" ", db.replace_escaped_characters ("\%"").is_equal ("%""))
			assert ("Test singel \ ", db.replace_escaped_characters ("\\").is_equal ("%H"))
			assert ("Test double \ ", db.replace_escaped_characters ("\\\\").is_equal ("\\"))
			assert ("Test newline ", db.replace_escaped_characters ("\n").is_equal ("%N"))
			assert ("Test tab ", db.replace_escaped_characters ("\t").is_equal ("%T"))
		end

  	test_roundtrip_of_escaped_characters
			-- New test routine
		note
			testing:  "covers/{NEO4J_DATABASE}.escape_characters"
			testing:  "covers/{NEO4J_DATABASE}.replace_escaped_characters"
		do
			assert (" Manage normal string", db.escape_characters (db.replace_escaped_characters ("AAAA")).is_equal ("AAAA"))
			assert (" 8th \", db.escape_characters (db.replace_escaped_characters ("\\\\\\\\")).is_equal ("\\\\\\\\"))
--			assert (" \ and then %"", db.escape_characters (db.replace_escaped_characters ("\%"")).is_equal ("\%""))
		end


end


